package hu.stunts.scr.apps;

import java.io.*;
import java.util.Arrays;

public class RplDirectory {

	private File directory;
	private String[] rplFileNames;
	
	private class RPLFilter implements FilenameFilter {
		public boolean accept(File dir, String name) {
			return (name.endsWith(".rpl")||name.endsWith(".RPL"));
		}
	}
	
	public RplDirectory (File dir) {
		if (dir.isDirectory()) {
			directory = dir;
			updateRplList();
		}
		else {
			directory = null;
			System.err.println("Non-directory passed to RplDirectory!");
		}
	}
	
	public final void updateRplList () {
		rplFileNames = directory.list(new RPLFilter());
		Arrays.sort(rplFileNames);
	}
	
	public String getFileName (int i) {
		return rplFileNames[i];
	}
	
	public String getDirPath () {
		return directory.getPath();
	}
	
	public int getRplCount () {
		return rplFileNames.length;
	}
	
	public int searchRplList (String name) {
		return Arrays.binarySearch(rplFileNames, name);
	}
}
