package hu.stunts.scr.utils;

import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.*;
import java.io.File;

public abstract class TxtParsing {
	

	public static String[] readPairFromTable(Scanner sc) {
		String[] pair = new String[2];
		if (sc.hasNext())
			pair[0] = sc.next();
		if (sc.hasNext())
			pair[1] = sc.next();
		return pair;
	}
	
	protected static Map<String, String> simpleMakeMapFromPairs(Scanner sc, int initSize) {
		String[] currentPair;
		Map<String, String> m = new HashMap<String, String>(initSize);
		while (sc.hasNext()) {
			currentPair = readPairFromTable(sc);
			m.put(currentPair[0], currentPair[1]);
		}
		return m;
	}
	
	public static Map<String, String> simpleMakeMapFromPairs(File txtTable, int initSize, boolean onlyTabsAsSep) {
		Map<String, String> m = null;
		if (txtTable.exists()) {
			try {
				Scanner sc;
				if (onlyTabsAsSep)
					sc = new Scanner(txtTable).useDelimiter("(\t)+|\n|\f|\r");
				else 
					sc = new Scanner(txtTable);
				m = simpleMakeMapFromPairs(sc, initSize);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}
		return m;
	}
	
	public static Map<String, String> simpleMakeMapFromPairs(InputStream txtStream, int initSize, boolean onlyTabsAsSep) {
		Map<String, String> m = null;
		Scanner sc;
		if (onlyTabsAsSep)
			sc = new Scanner(txtStream).useDelimiter("(\t)+|\n|\f|\r");
		else 
			sc = new Scanner(txtStream);
		m = simpleMakeMapFromPairs(sc, initSize);
		return m;
	}
	
	public static Map<String, String> simpleMakeMapFromPairs(File txtTable, int initSize) {
		return simpleMakeMapFromPairs(txtTable, initSize, false);
	}
	
	protected static Map<String, String[]> makeMultiValuedVarLengthMap(Scanner lineSc, int initSize, boolean onlyTabsAsSep) {
		Scanner arraySc;
		String currLine;
		Map<String, String[]> m = new HashMap<String, String[]>(initSize);
		while (lineSc.hasNext()) {
			String currentKey = null;
			String[] currentValues = null;
			List<String> valUpdateList = new ArrayList<String>();
			currLine = lineSc.next();
			if (onlyTabsAsSep)
				arraySc = new Scanner(currLine).useDelimiter("(\t)+|\n|\f|\r");
			else 
				arraySc = new Scanner(currLine);
			if (arraySc.hasNext())
				currentKey = arraySc.next();
			while (arraySc.hasNext()) {
				valUpdateList.add(arraySc.next());
			}
			currentValues = new String[valUpdateList.size()];
			valUpdateList.toArray(currentValues);
			valUpdateList.clear();
			m.put(currentKey, currentValues);
		}
		return m;
	}
	
	public static Map<String, String[]> makeMultiValuedVarLengthMap(File txtFile, int initSize, boolean onlyTabsAsSep) {
		Map<String, String[]> m = null;
		Scanner lineSc;
		try {
			lineSc = new Scanner(txtFile).useDelimiter("\n|\f|\r");
			m = makeMultiValuedVarLengthMap(lineSc, initSize, onlyTabsAsSep);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return m;
	}
	
	public static Map<String, String[]> makeMultiValuedVarLengthMap(InputStream txtStream, int initSize, boolean onlyTabsAsSep) {
		Map<String, String[]> m = null;
		Scanner lineSc = new Scanner(txtStream).useDelimiter("\n|\f|\r");
		m = makeMultiValuedVarLengthMap(lineSc, initSize, onlyTabsAsSep);
		return m;
	}
	
}
